
# for old GAP4 and GAP3
BlockDiagonalMatrix := function(arg)
  local n, res, i, j, rg, m;
  # unpack if matrices are given in a list
  if Length(arg) = 1 and not IsMatrix(arg[1]) then
    arg := arg[1];
  fi;
  n := Sum(arg, Length);
  res := (0*arg[1][1][1]) * NullMat(n, n);
  i := 0;
  for m in arg do
    j := i+Length(m);
    rg := [i+1..j];
    res{rg}{rg} := m;
    i := j;
  od;
  return res;
end;

###  aus ChevieMatsBn
BlockDiagMat := function(arg)
  local n, res, i, j, rg, m;
#  if Length(arg) = 1 and not IsMatrix(arg[1]) then
#    arg := arg[1];
#  fi;
  n := Sum(arg, Length);
  res := (0*arg[1][1][1]) * NullMat(n, n);
  i := 0;
  for m in arg do
    j := i+Length(m);
    rg := [i+1..j];
    res{rg}{rg} := m;
    i := j;
  od;
  return res;
end;
BrauerStem := function(arg)
local res,ind,i,j;
  res := IdentityMat(Sum(arg));
  ind:=0;
  for i in arg do
    for j in [2..i] do res[ind+j][ind+j-1] := 1; od;
    ind:=ind+i;
  od;
  return res;
end;
###  END



JordanBlockMatrix := function(eigenval, k)
  local o, res, i;
  o := One(eigenval);
  res := o * IdentityMat(k);
  for i in [2..k] do
    res[i][i-1] := o;
  od;
  return res;
end;

IndetVars := function(r)
  local v, nam;
  if IsBound(r.indets) then
    v := rec();
    for nam in r.indets do
      #v.(nam) := Indeterminate(Integers, nam);
      v.(nam) := Mvp(nam);
    od;
    return v;
  fi;
  return false;
end;
TestDecMatData := function(r)
  local cmps, lr, lc, m, k;
  cmps := ["d", "decmat", "hc_series", "ordinary", "name", "origin"];
  for k in cmps do
    if not IsBound(r.(k)) then
      Print("Missing ",k,":\n",r,"\n");
      return false;
    fi;
  od;
  lr := Length(r.ordinary);
  lc := Length(r.hc_series);
  m := r.decmat;
  if not (Length(m) = lr and ForAll(m, a-> Length(a) = lc)) then
##      Print("Wrong decmat: ",r,"\n");
    return false;
  else
    return true;
  fi;
end;
##  ##  Only works in GAP4
##  ApplyTestDecMatData := function()
##    local o, nam, res;
##    for nam in NamesUserGVars() do 
##      o := ValueGlobal(nam);
##      if IsRecord(o) and IsBound(o.decmat) then
##        res := TestDecMatData(o);
##        if res <> true then
##          Print(nam,"  ",TestDecMatData(o),"\n");
##        fi;
##      fi;
##    od;
##  end;
##  
##  InstallMethod(Browse, [IsRecord], function(r)
##    if not IsBound(r.decmat) then TryNextMethod(); fi;
##    NCurses.BrowseDenseList(r.decmat, rec( 
##      header := [Concatenation(r.name[1], String(r.name[2]),
##                ", d = ",String(r.d))],
##                convertEntry := NCurses.ReplaceZeroByDot,
##                labelsCol := [ r.hc_series ],
##                             labelsRow := List(r.ordinary, x-> [x])));
##  end);

# provide data as record components (useful in GAP3)
  2A2d2 := false;
  2A2d6 := false;
  2A3d2 := false;
  2A3d4 := false;
  2A3d6 := false;
  2A4d10 := false;
  2A4d2 := false;
  2A4d4 := false;
  2A4d6 := false;
  2A5d10 := false;
  2A5d2 := false;
  2A5d3 := false;
  2A5d4 := false;
  2A5d6 := false;
  2A6d10 := false;
  2A6d14 := false;
  2A6d2 := false;
  2A6d3 := false;
  2A6d4 := false;
  2A6d6 := false;
  2A7d10 := false;
  2A7d14 := false;
  2A7d2 := false;
  2A7d3 := false;
  2A7d4 := false;
  2A7d6 := false;
  2A7d8 := false;
  2A8d10 := false;
  2A8d14 := false;
  2A8d18 := false;
  2A8d2 := false;
  2A8d3 := false;
  2A8d4 := false;
  2A8d6 := false;
  2A8d8 := false;
  2A9d10 := false;
  2A9d14 := false;
  2A9d18 := false;
  2A9d2 := false;
  2A9d3 := false;
  2A9d4 := false;
  2A9d5 := false;
  2A9d6 := false;
  2A9d8 := false;
  2D4d2 := false;
  2D4d3 := false;
  2D4d4 := false;
  2D4d6 := false;
  2D4d8 := false;
  2D5d2 := false;
  2D5d3 := false;
  2D5d4 := false;
  2D5d6 := false;
  2D5d8 := false;
  2D6d10 := false;
  2D6d12 := false;
  2D6d2 := false;
  2D6d3 := false;
  2D6d4 := false;
  2D6d5 := false;
  2D6d6 := false;
  2D6d8 := false;
  2D7d10 := false;
  2D7d12 := false;
  2D7d14 := false;
  2D7d3 := false;
  2D7d4 := false;
  2D7d5 := false;
  2D7d6 := false;
  2D7d8 := false;
  2D8d6 := false;
  2D9d6 := false;
  A1d2 := false;
  A2d2 := false;
  A2d3 := false;
  A3d2 := false;
  A3d3 := false;
  A3d4 := false;
  A4d2 := false;
  A4d3 := false;
  A4d4 := false;
  A4d5 := false;
  A5d2 := false;
  A5d3 := false;
  A5d4 := false;
  A5d5 := false;
  A5d6 := false;
  A6d2 := false;
  A6d3 := false;
  A6d4 := false;
  A6d5 := false;
  A6d6 := false;
  A6d7 := false;
  A7d2 := false;
  A7d3 := false;
  A7d4 := false;
  A7d5 := false;
  A7d6 := false;
  A7d7 := false;
  A7d8 := false;
  A8d2 := false;
  A8d3 := false;
  A8d4 := false;
  A8d5 := false;
  A8d6 := false;
  A8d7 := false;
  A8d8 := false;
  A8d9 := false;
  A9d10 := false;
  A9d2 := false;
  A9d3 := false;
  A9d4 := false;
  A9d5 := false;
  A9d6 := false;
  A9d7 := false;
  A9d8 := false;
  A9d9 := false;
  B2d2 := false;
  B2d4 := false;
  B3d2 := false;
  B3d3 := false;
  B3d4 := false;
  B3d6 := false;
  B4d2 := false;
  B4d3 := false;
  B4d4 := false;
  B4d6 := false;
  B4d8 := false;
  B5d3 := false;
  B5d6 := false;
  B6d3 := false;
  B6d6 := false;
  B7d6 := false;
  B8d6 := false;
  D4d2 := false;
  D4d3 := false;
  D4d4 := false;
  D4d6 := false;
  D5d2 := false;
  D5d3 := false;
  D5d4 := false;
  D5d5 := false;
  D5d6 := false;
  D5d8 := false;
  D6d10 := false;
  D6d2 := false;
  D6d3 := false;
  D6d4 := false;
  D6d5 := false;
  D6d6 := false;
  D6d8 := false;
  D7d10 := false;
  D7d12 := false;
  D7d3 := false;
  D7d4 := false;
  D7d5 := false;
  D7d6 := false;
  D7d7 := false;
  D7d8 := false;

DECMATS := rec();
MakeDecMatRecord := function()
  DECMATS.2A2d2 := 2A2d2;
  DECMATS.2A2d6 := 2A2d6;
  DECMATS.2A3d2 := 2A3d2;
  DECMATS.2A3d4 := 2A3d4;
  DECMATS.2A3d6 := 2A3d6;
  DECMATS.2A4d10 := 2A4d10;
  DECMATS.2A4d2 := 2A4d2;
  DECMATS.2A4d4 := 2A4d4;
  DECMATS.2A4d6 := 2A4d6;
  DECMATS.2A5d10 := 2A5d10;
  DECMATS.2A5d2 := 2A5d2;
  DECMATS.2A5d3 := 2A5d3;
  DECMATS.2A5d4 := 2A5d4;
  DECMATS.2A5d6 := 2A5d6;
  DECMATS.2A6d10 := 2A6d10;
  DECMATS.2A6d14 := 2A6d14;
  DECMATS.2A6d2 := 2A6d2;
  DECMATS.2A6d3 := 2A6d3;
  DECMATS.2A6d4 := 2A6d4;
  DECMATS.2A6d6 := 2A6d6;
  DECMATS.2A7d10 := 2A7d10;
  DECMATS.2A7d14 := 2A7d14;
  DECMATS.2A7d2 := 2A7d2;
  DECMATS.2A7d3 := 2A7d3;
  DECMATS.2A7d4 := 2A7d4;
  DECMATS.2A7d6 := 2A7d6;
  DECMATS.2A7d8 := 2A7d8;
  DECMATS.2A8d10 := 2A8d10;
  DECMATS.2A8d14 := 2A8d14;
  DECMATS.2A8d18 := 2A8d18;
  DECMATS.2A8d2 := 2A8d2;
  DECMATS.2A8d3 := 2A8d3;
  DECMATS.2A8d4 := 2A8d4;
  DECMATS.2A8d6 := 2A8d6;
  DECMATS.2A8d8 := 2A8d8;
  DECMATS.2A9d10 := 2A9d10;
  DECMATS.2A9d14 := 2A9d14;
  DECMATS.2A9d18 := 2A9d18;
  DECMATS.2A9d2 := 2A9d2;
  DECMATS.2A9d3 := 2A9d3;
  DECMATS.2A9d4 := 2A9d4;
  DECMATS.2A9d5 := 2A9d5;
  DECMATS.2A9d6 := 2A9d6;
  DECMATS.2A9d8 := 2A9d8;
  DECMATS.2D4d2 := 2D4d2;
  DECMATS.2D4d3 := 2D4d3;
  DECMATS.2D4d4 := 2D4d4;
  DECMATS.2D4d6 := 2D4d6;
  DECMATS.2D4d8 := 2D4d8;
  DECMATS.2D5d2 := 2D5d2;
  DECMATS.2D5d3 := 2D5d3;
  DECMATS.2D5d4 := 2D5d4;
  DECMATS.2D5d6 := 2D5d6;
  DECMATS.2D5d8 := 2D5d8;
  DECMATS.2D6d10 := 2D6d10;
  DECMATS.2D6d12 := 2D6d12;
  DECMATS.2D6d2 := 2D6d2;
  DECMATS.2D6d3 := 2D6d3;
  DECMATS.2D6d4 := 2D6d4;
  DECMATS.2D6d5 := 2D6d5;
  DECMATS.2D6d6 := 2D6d6;
  DECMATS.2D6d8 := 2D6d8;
  DECMATS.2D7d10 := 2D7d10;
  DECMATS.2D7d12 := 2D7d12;
  DECMATS.2D7d14 := 2D7d14;
  DECMATS.2D7d3 := 2D7d3;
  DECMATS.2D7d4 := 2D7d4;
  DECMATS.2D7d5 := 2D7d5;
  DECMATS.2D7d6 := 2D7d6;
  DECMATS.2D7d8 := 2D7d8;
  DECMATS.2D8d6 := 2D8d6;
  DECMATS.2D9d6 := 2D9d6;
  DECMATS.A1d2 := A1d2;
  DECMATS.A2d2 := A2d2;
  DECMATS.A2d3 := A2d3;
  DECMATS.A3d2 := A3d2;
  DECMATS.A3d3 := A3d3;
  DECMATS.A3d4 := A3d4;
  DECMATS.A4d2 := A4d2;
  DECMATS.A4d3 := A4d3;
  DECMATS.A4d4 := A4d4;
  DECMATS.A4d5 := A4d5;
  DECMATS.A5d2 := A5d2;
  DECMATS.A5d3 := A5d3;
  DECMATS.A5d4 := A5d4;
  DECMATS.A5d5 := A5d5;
  DECMATS.A5d6 := A5d6;
  DECMATS.A6d2 := A6d2;
  DECMATS.A6d3 := A6d3;
  DECMATS.A6d4 := A6d4;
  DECMATS.A6d5 := A6d5;
  DECMATS.A6d6 := A6d6;
  DECMATS.A6d7 := A6d7;
  DECMATS.A7d2 := A7d2;
  DECMATS.A7d3 := A7d3;
  DECMATS.A7d4 := A7d4;
  DECMATS.A7d5 := A7d5;
  DECMATS.A7d6 := A7d6;
  DECMATS.A7d7 := A7d7;
  DECMATS.A7d8 := A7d8;
  DECMATS.A8d2 := A8d2;
  DECMATS.A8d3 := A8d3;
  DECMATS.A8d4 := A8d4;
  DECMATS.A8d5 := A8d5;
  DECMATS.A8d6 := A8d6;
  DECMATS.A8d7 := A8d7;
  DECMATS.A8d8 := A8d8;
  DECMATS.A8d9 := A8d9;
  DECMATS.A9d10 := A9d10;
  DECMATS.A9d2 := A9d2;
  DECMATS.A9d3 := A9d3;
  DECMATS.A9d4 := A9d4;
  DECMATS.A9d5 := A9d5;
  DECMATS.A9d6 := A9d6;
  DECMATS.A9d7 := A9d7;
  DECMATS.A9d8 := A9d8;
  DECMATS.A9d9 := A9d9;
  DECMATS.B2d2 := B2d2;
  DECMATS.B2d4 := B2d4;
  DECMATS.B3d2 := B3d2;
  DECMATS.B3d3 := B3d3;
  DECMATS.B3d4 := B3d4;
  DECMATS.B3d6 := B3d6;
  DECMATS.B4d2 := B4d2;
  DECMATS.B4d3 := B4d3;
  DECMATS.B4d4 := B4d4;
  DECMATS.B4d6 := B4d6;
  DECMATS.B4d8 := B4d8;
  DECMATS.B5d3 := B5d3;
  DECMATS.B5d6 := B5d6;
  DECMATS.B6d3 := B6d3;
  DECMATS.B6d6 := B6d6;
  DECMATS.B7d6 := B7d6;
  DECMATS.B8d6 := B8d6;
  DECMATS.D4d2 := D4d2;
  DECMATS.D4d3 := D4d3;
  DECMATS.D4d4 := D4d4;
  DECMATS.D4d6 := D4d6;
  DECMATS.D5d2 := D5d2;
  DECMATS.D5d3 := D5d3;
  DECMATS.D5d4 := D5d4;
  DECMATS.D5d5 := D5d5;
  DECMATS.D5d6 := D5d6;
  DECMATS.D5d8 := D5d8;
  DECMATS.D6d10 := D6d10;
  DECMATS.D6d2 := D6d2;
  DECMATS.D6d3 := D6d3;
  DECMATS.D6d4 := D6d4;
  DECMATS.D6d5 := D6d5;
  DECMATS.D6d6 := D6d6;
  DECMATS.D6d8 := D6d8;
  DECMATS.D7d10 := D7d10;
  DECMATS.D7d12 := D7d12;
  DECMATS.D7d3 := D7d3;
  DECMATS.D7d4 := D7d4;
  DECMATS.D7d5 := D7d5;
  DECMATS.D7d6 := D7d6;
  DECMATS.D7d7 := D7d7;
  DECMATS.D7d8 := D7d8;
end;

